/*********************************************************************************

 ** Universidade Nova de Lisboa - Faculdade de Ciências e Tecnologia

 **

 ** Protocolo XORi - flatbeacon_cache.h

 **

 ** Autores:

 ** André Garrido

 ** Rodolfo Oliveira

 **

 ** 1 de Março de 2010

** **********************************************************************************/

#ifndef FLATBEACON_CACHE_H_
#define FLATBEACON_CACHE_H_


#include <set>
#include <vector>
#include <config.h>
#include <map>
#include <string>
#include  <timer-handler.h>





class flatbeacon_cache{

public:
	int** query_cache;    //Query's matriz
	int** response_cache; ////Response's matriz
	int n_nodes_;		 /// Number of nodes
	int* query_cache_control;  /// Query cache list
	int* response_cache_control; /// Responde cache list


	flatbeacon_cache(int);
	void update_query_cache(int,int,int);
	int update_query_cache_control(int);
	void update_response_cache(int,int,int);
	int update_response_cache_control(int);
	bool confirm_node(int,int,int,int);
	void print_query_cache();



};





#endif /* FLATBEACON_CACHE_H_ */
