/*********************************************************************************

 ** Universidade Nova de Lisboa - Faculdade de Ciências e Tecnologia

 **

 ** Protocolo XORi - flatbeacon_neigb_table.h

 **

 ** Autores:

 ** André Garrido

 ** Rodolfo Oliveira

 **

 ** 1 de Março de 2010

** **********************************************************************************/

#ifndef __flatbeacon_neigb_table_h__
#define __flatbeacon_neigb_table_h__

#include <set>
#include <vector>
#include <config.h>
#include <map>
#include <string>
#include  <timer-handler.h>
#include "flatbeacon.h"


//#include  "../r0_clustering/cbc_table.h"
#include "flatbeacon_repositories.h"

class flatbeacon_neib_node;
class flatbeacon;


typedef std::vector<flatbeacon_neib_node*>   array_nodes; //neighbors's array in each bucket
typedef std::map<int,array_nodes > buck_neib;





class flatbeacon_neigb_table {

public:

	buck_neib bk_;
	nsaddr_t source_;
	flatbeacon* flat_;


	flatbeacon_neigb_table(flatbeacon*, nsaddr_t);
	void	print(nsaddr_t,int);
	void	clear();
	void	rm_entry(nsaddr_t*,int);
	void	add_entry(nsaddr_t,nsaddr_t,nsaddr_t,int,int,int,int,int,int,bool);
	void	add_entry_resp(nsaddr_t,nsaddr_t,nsaddr_t,int,int,bool,int,int,int,int,
			int,int,int,int,bool);
	bool	buck_query(int,int,vector<int>*);
	bool search_nodes_bucks(nsaddr_t src, vector<int> buckets,int code,vector<int>* resul_find_neib,int *count, vector<int>* resul_num_hop,
			vector<int>* result_cols, vector<int>* resul_lines,vector<int>* type,vector<int>* result_id);
	void insert_neib_query(nsaddr_t src, vector<int> neibs,nsaddr_t orig,int code, vector<int> neib_hop,
			int num_hops,bool,int,int,int,int,vector<int>, vector<int>, vector<int>, vector<int>);
	void insert_neib_bgl(nsaddr_t src, vector<int> neibs,nsaddr_t orig,int code, vector<int> neib_hop,
			int num_hops,vector<int>, vector<int>, vector<int>, vector<int>);
	void update_timer_neib(nsaddr_t,int);

};



#endif
