/*********************************************************************************

 ** Universidade Nova de Lisboa - Faculdade de Ciências e Tecnologia

 **

 ** Protocolo XORi - flatbeacon_pkt.h

 **

 ** Autores:

 ** André Garrido

 ** Rodolfo Oliveira

 **

 ** 1 de Março de 2010

** **********************************************************************************/


#ifndef __flatbeacon_pkt_h__
#define __flatbeacon_pkt_h__
#include <packet.h>






struct hdr_flatbeacon_pkt {

     nsaddr_t   pkt_src_;     // Node which originated this packet
     u_int16_t pkt_len_;      // Packet length (in bytes)
     u_int8_t   pkt_seq_num_; // Packet sequence number

     inline     nsaddr_t&   pkt_src()     { return pkt_src_; }
     inline     u_int16_t& pkt_len()      { return pkt_len_; }
     inline     u_int8_t&   pkt_seq_num() { return pkt_seq_num_; }

     static int offset_;
     inline static int& offset() { return offset_; }
     inline static hdr_flatbeacon_pkt* access(const Packet* p) {
         return (hdr_flatbeacon_pkt*)p->access(offset_);
     }

};

#endif

