/*********************************************************************************

 ** Universidade Nova de Lisboa - Faculdade de Ciências e Tecnologia

 **

 ** Protocolo XORi - flatbeacon_repositories.h

 **

 ** Autores:

 ** André Garrido

 ** Rodolfo Oliveira

 **

 ** 1 de Março de 2010

** **********************************************************************************/

#ifndef __FLATBEACON_REPOSITORIES_H__
#define __FLATBEACON_REPOSITORIES_H__

#include <config.h>
#include <map>
#include  <timer-handler.h>
#include "flatbeacon_neigb_table.h"

#define NODE_TIMEOUT 	5   ///Node timeout

///Message's types
#define MSG_QUERY	1
#define MSG_RESP	2
#define MSG_HELLO	3





class flatbeacon_neib_node;
class flatbeacon_neigb_table;

class flatbeacon_Timer_del_neib : public TimerHandler {
private:
	virtual void expire(Event *e);
	flatbeacon_neib_node* a_;

public:

	flatbeacon_Timer_del_neib(flatbeacon_neib_node* a) : TimerHandler() {
		a_=a;

	};
};

class flatbeacon_neib_node
{

	friend class flatbeacon_Timer_del_neib;

public:

	flatbeacon_neib_node(int);

	nsaddr_t dest_addr_;	//destination address
	nsaddr_t next_hop_addr_;	// next hop address
	int code_;				// number of bits
	int num_hops_;			// number of hops
	int type_msg_;			// type of message
	int line_;				// line's number
	int col_;				// col's number
	int id_;				// ID
	bool for_query;			// the node is suited for query


	flatbeacon_Timer_del_neib timer;
	flatbeacon_neigb_table *neig_table;


	inline nsaddr_t&	nb_dest_addr()	{ return dest_addr_; }
	inline nsaddr_t&	nb_next_hop_addt() { return next_hop_addr_;}
	inline int&		nb_num_hops() { return num_hops_;}
	inline int&		nb_type_msg() { return type_msg_;}
	inline int&		nb_line() {return line_;}
	inline int&		nb_col() {return col_;}
	inline int&		nb_id() {return id_;}


};


#endif /* FLATBEACON_REPOSITORIES_H_ */
