/*********************************************************************************

 ** Universidade Nova de Lisboa - Faculdade de Ciências e Tecnologia

 **

 ** Protocolo XOR - flatrouting_cache.cc

 **

 ** Autores:

 ** André Garrido

 ** Rodolfo Oliveira

 **

 ** 1 de Março de 2010

** **********************************************************************************/

#include <vector>
#include <math.h>
#include "flatrouting_cache.h"





////Inicializes the query/responses matriz and list
flatrouting_cache::flatrouting_cache(int n_nodes)
{

	n_nodes_= n_nodes;

	query_cache= (int**)calloc(n_nodes,sizeof(int*));
	response_cache= (int**)calloc(n_nodes,sizeof(int*));

	query_cache_control=(int*)calloc(n_nodes,sizeof(int));
	response_cache_control= (int*)calloc(n_nodes,sizeof(int));

	for(int i= 0; i< n_nodes;i++)
	{
		response_cache[i]= (int*)calloc(n_nodes,sizeof(int));
		query_cache[i]= (int*)calloc(n_nodes,sizeof(int));
	}


	for(int i= 0; i< n_nodes;i++)
	{
		query_cache_control[i]= 0;
		response_cache_control[i]= 0;

		for(int n=0; n< n_nodes;n++)
		{
			query_cache[i][n]= 0;
			response_cache[i][n]= 0;
		}
	}

}


/// Updates the new id in the query matriz
void flatrouting_cache::update_query_cache(int lin,int col,int id)
{
	query_cache[lin][col]= id;
}

/// Updates the new id in the response matriz
void flatrouting_cache::update_response_cache(int lin, int col, int id)
{
	response_cache[lin][col]= id;
}

/// Updates the new id in the query cache list
int flatrouting_cache::update_query_cache_control(int dest)
{
	int id= query_cache_control[dest];

	query_cache_control[dest]= id+1;

	return query_cache_control[dest];
}

/// Updates the new id in the response cache list
int flatrouting_cache::update_response_cache_control(int dest)
{
	int id= response_cache_control[dest];

	response_cache_control[dest]= id+1;

	return response_cache_control[dest];
}

///Confirms the id.
bool flatrouting_cache::confirm_node(int lin,int col, int type,int id)
{

	if(type == 1)
	{
		if(query_cache[lin][col] >= id)
			return false;
		else
			return true;
	} else if(type == 2)
	{
		if(response_cache[lin][col] >= id)
			return false;
		else
			return true;
	}else
		return true;
}


/// Prints the query and response matriz
void flatrouting_cache::print_query_cache()
{
	printf("QUERY\n\n");

	for(int i=0 ; i < n_nodes_; i++)
	{
		for(int n=0; n < n_nodes_; n++)
		{
			printf("|%i|",query_cache[i][n]);

		}
		printf("\n");
	}

	printf("\nRESPONSE\n");

	for(int i=0 ; i < n_nodes_; i++)
	{
		for(int n=0; n < n_nodes_; n++)
		{
			printf("|%i|",response_cache[i][n]);

		}
		printf("\n");
	}
}
